"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const generator_helper_1 = require("@prisma/generator-helper");
const sdk_1 = require("@prisma/sdk");
const node_plop_1 = __importDefault(require("node-plop"));
const path = __importStar(require("path"));
const transformDMMF_1 = require("./generator/transformDMMF");
// eslint-disable-next-line @typescript-eslint/no-var-requires
// const pkg = require('../package.json');
(0, generator_helper_1.generatorHandler)({
    onManifest() {
        return {
            defaultOutput: './sequelize',
            prettyName: 'Sequelize Models',
        };
    },
    onGenerate(options) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!options.generator.output) {
                throw new Error('No output was specified for Prisma Sequelize Generator');
            }
            const outputDir = 
            // This ensures previous version of prisma are still supported
            typeof options.generator.output === 'string'
                ? options.generator.output
                : (0, sdk_1.parseEnvValue)(options.generator.output);
            try {
                const plop = (0, node_plop_1.default)(path.join(__dirname, '../plop/plopfile.js'), { destBasePath: outputDir, force: true });
                // const utilsGenerator = plop.getGenerator('utils');
                const indexGenerator = plop.getGenerator('index.ts');
                const modelGenerator = plop.getGenerator('Model.ts');
                const schemaDir = options.schemaPath ? path.dirname(options.schemaPath) : process.cwd();
                const schemaPath = path.join(schemaDir, 'prisma.schema');
                const envPaths = (0, sdk_1.getEnvPaths)(schemaPath, { cwd: outputDir });
                const config = {
                    generator: options.generator,
                    relativeEnvPaths: {
                        rootEnvPath: envPaths.rootEnvPath && path.relative(outputDir, envPaths.rootEnvPath),
                        schemaEnvPath: envPaths.schemaEnvPath && path.relative(outputDir, envPaths.schemaEnvPath),
                    },
                    // relativePath: path.relative(outputDir, schemaDir),
                    // clientVersion: pkg.version,
                    // engineVersion: options.version,
                    // datasourceNames: options.datasources.map((d) => d.name),
                    datasource: options.datasources[0],
                };
                // const relativeOutputDir = path.relative(process.cwd(), outputDir);
                // const slsRelativeOutputDir = path.relative(process.cwd(), outputDir).split(path.sep).slice(1).join(path.sep);
                const { models } = (0, transformDMMF_1.transformDMMF)(options.dmmf);
                yield Promise.all([
                    // utilsGenerator.runActions({}),
                    indexGenerator.runActions({ models, config: JSON.stringify(config, null, 2) }),
                    ...models.map((model) => modelGenerator.runActions(model)),
                ]);
            }
            catch (e) {
                console.error('Error: unable to write files for Prisma Sequelize Generator');
                throw e;
            }
        });
    },
});
